/*****************   MAIN PROGRAM ****************
 *
 * Indira Vidyaprakash June 19 , 1996
 * 
 ***************************************************/
 


import java.awt.*;
import java.net.*;
import java.applet.Applet;
import java.io.*;



public class MainProgram extends Applet implements Runnable {

  // Initialize all the Interface Panel variables HERE
  public double d = 30.0, f = 70.0, h = 20.0;
  public double fromx = 50.0, fromy = 0.0, fromz = 0.0;
  public double upx = 0.0, upy = 0.0, upz = 1.0;
  public double tox = 0.0, toy = 0.0, toz = 0.0;
  
  URL urlName;
  String objfile = null;

   
  InterfacePanel uipanel;
  DrawCanvas thecanvas;

    
public void init(){

  // Get Document Base
  urlName = getDocumentBase();
  objfile = getParameter("model");
  
  // This is the layout for the base
  setLayout(new GridLayout(0,2));

  // Instantiate the User Interface Panel 
  uipanel = new InterfacePanel(this);
  thecanvas = new DrawCanvas(this);
  

  add(uipanel);
  add(thecanvas);
  
  validate();

}

public void start(){

  new Thread(this).start();
}
  
public void stop(){
}

public void run(){
  Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
  repaint();
}

public void paint(Graphics g){
  
  thecanvas.world.repaint();
  thecanvas.view.repaint();
  thecanvas.persp.repaint();
  thecanvas.proj.repaint();
   
}


    
  
  // To process the action Events in the Interface - TextField, Choice and Button
  
  
    
 public boolean action(Event e, Object arg){
  
   if (e.target instanceof TextField){
    

     double value = Integer.valueOf((((TextField)e.target).getText())).doubleValue() + 0.0;

     
     // Processing the D,F and H TextField
     if(e.target == uipanel.d_text){
       thecanvas.view.d = value;
       thecanvas.persp.d = value;
       thecanvas.world.d = value;
       thecanvas.proj.d = value;
     }
     else if (e.target == uipanel.f_text){
       thecanvas.view.f = value;
       thecanvas.persp.f = value;
       thecanvas.world.f = value;
       thecanvas.proj.f = value;
     }
     else if(e.target == uipanel.h_text){
       thecanvas.view.h = value;
       thecanvas.persp.h = value;
       thecanvas.world.h = value;
      thecanvas.proj.h = value; 
     }

      
     //Processing the From Vector TextField
     else if(e.target == uipanel.fromx){
       thecanvas.view.fromx = value;
       thecanvas.persp.fromx = value;
       thecanvas.world.fromx = value;
        thecanvas.proj.fromx = value;
       
	 }
     else if(e.target == uipanel.fromy){
       thecanvas.view.fromy = value;
       thecanvas.persp.fromy = value;
       thecanvas.world.fromy = value;
       thecanvas.proj.fromy = value;
     }
     else if(e.target == uipanel.fromz){
       thecanvas.view.fromz = value;
       thecanvas.persp.fromz = value;
       thecanvas.world.fromz = value ;
       thecanvas.proj.fromz = value ;
     }
     
     else if(e.target == uipanel.tox){
       thecanvas.view.tox = value;
       thecanvas.persp.tox = value;
       thecanvas.world.tox = value;
       thecanvas.proj.tox = value;
     }
     else if(e.target == uipanel.toy){
       thecanvas.view.toy = value;
       thecanvas.persp.toy = value;
       thecanvas.world.toy = value;
       thecanvas.proj.toy = value;
     }
     else if(e.target == uipanel.toz){
       thecanvas.view.toz = value;
       thecanvas.persp.toz = value;
        thecanvas.world.toz = value;
	  thecanvas.proj.toz = value;
     }

     else if(e.target == uipanel.upx){
       thecanvas.view.upx = value;
       thecanvas.persp.upx = value;
       thecanvas.world.upx = value;
       thecanvas.proj.upx = value;
     }
     else if(e.target == uipanel.upy){
        thecanvas.view.upy = value;
	thecanvas.persp.upy = value;
	thecanvas.world.upy = value;
	thecanvas.proj.upy = value;
     }
     else if(e.target == uipanel.upz){
       thecanvas.view.upz = value;
       thecanvas.persp.upz = value;
       thecanvas.world.upz = value;
       thecanvas.proj.upz = value;
     }   

     // Not any of the TextFields
     else
       return false;

   
     repaint();
     return true;
   }
    
   
    else if (e.target instanceof Button) { 

     if(e.target == uipanel.fromxless) {
       // Change in the TextField
       double less = Integer.valueOf((uipanel.fromx).getText()).doubleValue() - 1.0;
       (uipanel.fromx).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.fromx = less;
       thecanvas.persp.fromx = less;
       thecanvas.world.fromx = less;
        thecanvas.proj.fromx = less;
     }
     else if (e.target == uipanel.fromxmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.fromx).getText()).doubleValue() + 1.0;
       (uipanel.fromx).setText(String.valueOf(more));
       // Change the View Frustrum
      thecanvas.view.fromx = more;
      thecanvas.persp.fromx = more;
      thecanvas.world.fromx = more;
       thecanvas.proj.fromx = more;
     }
     else if (e.target == uipanel.fromyless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.fromy).getText()).doubleValue() - 1.0;
       (uipanel.fromy).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.fromy = less;
       thecanvas.persp.fromy = less;
       thecanvas.world.fromy = less;
       thecanvas.proj.fromy = less;
     }
     else if (e.target == uipanel.fromymore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.fromy).getText()).doubleValue() + 1.0;
       (uipanel.fromy).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.fromy = more;
       thecanvas.persp.fromy = more;
      thecanvas.world.fromy = more;
      thecanvas.proj.fromy = more;
     }

     else if (e.target == uipanel.fromzless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.fromz).getText()).doubleValue() - 1.0;
       (uipanel.fromz).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.fromz = less;
       thecanvas.persp.fromz = less;
       thecanvas.world.fromz = less;
       thecanvas.proj.fromz = less;
     }
     else if (e.target == uipanel.fromzmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.fromz).getText()).doubleValue() + 1.0;
       (uipanel.fromz).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.fromz = more;
       thecanvas.persp.fromz = more;
      thecanvas.world.fromz = more;
     thecanvas.proj.fromz = more; 
     }

     else if (e.target == uipanel.toxless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.tox).getText()).doubleValue() - 1.0;
       (uipanel.tox).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.tox = less;
       thecanvas.persp.tox = less;
       thecanvas.world.tox = less;
       thecanvas.proj.tox = less;
     }
     else if (e.target == uipanel.toxmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.tox).getText()).doubleValue() + 1.0;
       (uipanel.tox).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.tox = more;
       thecanvas.persp.tox = more;
        thecanvas.world.tox = more;
	thecanvas.proj.tox = more;
     }

      else if (e.target == uipanel.toyless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.toy).getText()).doubleValue() - 1.0;
       (uipanel.toy).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.toy = less;
       thecanvas.persp.toy = less;
        thecanvas.world.toy = less;
	thecanvas.proj.toy = less;
     }
     else if (e.target == uipanel.toymore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.toy).getText()).doubleValue() + 1.0;
       (uipanel.toy).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.toy = more;
       thecanvas.persp.toy = more;
       thecanvas.world.toy = more;
       thecanvas.proj.toy = more;
     }

     else if (e.target == uipanel.tozless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.toz).getText()).doubleValue() - 1.0;
       (uipanel.toz).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.toz = less;
       thecanvas.persp.toz = less;
       thecanvas.world.toz = less;
       thecanvas.proj.toz = less;
     }
     else if (e.target == uipanel.tozmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.toz).getText()).doubleValue() + 1.0;
       (uipanel.toz).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.toz = more;
       thecanvas.persp.toz = more;
        thecanvas.world.toz = more;
	thecanvas.proj.toz = more;
     }

     else if (e.target == uipanel.upxless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.upx).getText()).doubleValue() - 1.0;
       (uipanel.upx).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.upx = less;
       thecanvas.persp.upx = less;
       thecanvas.world.upx = less;
       thecanvas.proj.upx = less;
     }
     else if (e.target == uipanel.upxmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.upx).getText()).doubleValue() + 1.0;
       (uipanel.upx).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.upx = more;
       thecanvas.persp.upx = more;
       thecanvas.world.upx = more;
        thecanvas.proj.upx = more;
     }
     else if (e.target == uipanel.upyless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.upy).getText()).doubleValue() - 1.0;
       (uipanel.upy).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.upy = less;
       thecanvas.persp.upy = less;
        thecanvas.world.upy = less;
	 thecanvas.proj.upy = less;
     }
     else if (e.target == uipanel.upymore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.upy).getText()).doubleValue() + 1.0;
       (uipanel.upy).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.upy = more;
       thecanvas.persp.upy = more;
        thecanvas.world.upy = more;
	 thecanvas.proj.upy = more;
     }
     else if (e.target == uipanel.upzless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.upz).getText()).doubleValue() - 1.0;
       (uipanel.upz).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.view.upz = less;
       thecanvas.persp.upz = less;
       thecanvas.world.upz = less;
       thecanvas.proj.upz = less;
     }
     else if (e.target == uipanel.upzmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.upz).getText()).doubleValue() + 1.0;
       (uipanel.upz).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.view.upz = more;
       thecanvas.persp.upz = more;
       thecanvas.world.upz = more;
       thecanvas.proj.upz = more;
     }

     else if (e.target == uipanel.nearless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.d_text).getText()).doubleValue() - 1.0;
       (uipanel.d_text).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.persp.d = less;
       thecanvas.view.d = less;
       thecanvas.world.d = less;
       thecanvas.proj.d = less;
     }
     else if (e.target == uipanel.nearmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.d_text).getText()).doubleValue() + 1.0;
       (uipanel.d_text).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.persp.d = more;
       thecanvas.view.d = more;
        thecanvas.world.d = more;
	thecanvas.proj.d = more;
     }

      else if (e.target == uipanel.farless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.f_text).getText()).doubleValue() - 1.0;
       (uipanel.f_text).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.persp.f = less;
       thecanvas.view.f = less;
        thecanvas.world.f = less;
	thecanvas.proj.f = less;
     }
     else if (e.target == uipanel.farmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.f_text).getText()).doubleValue() + 1.0;
       (uipanel.f_text).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.persp.f = more;
       thecanvas.view.f = more;
       thecanvas.world.f = more;
       thecanvas.proj.f = more;
     }

     else if (e.target == uipanel.htless) {
       // Change in the TextField
       double less= Integer.valueOf((uipanel.h_text).getText()).doubleValue() - 1.0;
       (uipanel.h_text).setText(String.valueOf(less));
       // Change the View Frustrum
       thecanvas.persp.h = less;
       thecanvas.view.h = less;
        thecanvas.world.h = less;
	 thecanvas.proj.h = less;
     }
     else if (e.target == uipanel.htmore) {
       // Change in the TextField
       double more = Integer.valueOf((uipanel.h_text).getText()).doubleValue() + 1.0;
       (uipanel.h_text).setText(String.valueOf(more));
       // Change the View Frustrum
       thecanvas.persp.h = more;
       thecanvas.view.h = more;
       thecanvas.world.h = more;
       thecanvas.proj.h = more;
     }
     
     // Not any of the Buttons
     else
       return false;

     repaint();
     return true;
    }

   else
    return false;
 }

  
}




